// ImageProcessingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImageProcessing.h"
#include "ImageProcessingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CImageProcessingDlg dialog




CImageProcessingDlg::CImageProcessingDlg(CWnd* pParent /*=NULL*/)
: CDialog(CImageProcessingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImageProcessingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CImageProcessingDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_IMAGELOAD, &CImageProcessingDlg::OnBnClickedImageload)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_MESHFORMAT, &CImageProcessingDlg::OnBnClickedMeshformat)
	ON_BN_CLICKED(IDC_MESHSET, &CImageProcessingDlg::OnBnClickedMeshset)
	ON_BN_CLICKED(IDC_APPLY, &CImageProcessingDlg::OnBnClickedApply)
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()


// CImageProcessingDlg message handlers

BOOL CImageProcessingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CImageProcessingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CImageProcessingDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if ( !m_ViewImage->IsNull() )
		{
		//	m_ScrImage->Draw(dc, 0, 0);
			m_ViewImage->Draw(dc,0,0);
		}

		CBrush brush(RGB(0,255,0));
		dc.SelectObject(&brush);

		for(int j=0; j<MeshSizeY; j++)
		{
			for(int i=0; i<MeshSizeX; i++)
			{
				if(i < MeshSizeX-1)
				{
					dc.MoveTo(m_NewMesh[i][j].x, m_NewMesh[i][j].y);
					dc.LineTo(m_NewMesh[i+1][j].x, m_NewMesh[i+1][j].y);
				}
				if(j < MeshSizeY-1)
				{
					dc.MoveTo(m_NewMesh[i][j].x, m_NewMesh[i][j].y);
					dc.LineTo(m_NewMesh[i][j+1].x, m_NewMesh[i][j+1].y);
				}
				// ܰ ޽ ϰ Ҽ ִ 簢 ׷ش.
				if(i && j && i<MeshSizeX-1 && j<MeshSizeY-1)
					dc.Rectangle(m_NewMesh[i][j].x-5, m_NewMesh[i][j].y-5, m_NewMesh[i][j].x+5, m_NewMesh[i][j].y+5);
			}
		}

		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CImageProcessingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CImageProcessingDlg::OnBnClickedImageload()
{
	// TODO: Add your control notification handler code here
	// Get image file name
	CString szFilter = L"Image Files(*.BMP, *.GIF, *.JPG, *.PNG) | *.BMP;*.GIF;*.JPG;*.PNG; | All Files(*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);
	if(IDOK != dlg.DoModal()) return;
	CString sFilename = dlg.GetPathName();

	// Detaches the bitmap from the CImage object and destroys the bitmap if image already loaded
	CImage image;
	image.Load(sFilename);

	if ( !m_ScrImage->IsNull() )
	{
		m_ScrImage->Destroy();
	}
	m_ScrImage->Load(sFilename);

	if ( !m_ViewImage->IsNull() )
	{
		m_ViewImage->Destroy();
	}
	m_ViewImage->Create(m_ScrImage->GetWidth(), m_ScrImage->GetHeight(), m_ScrImage->GetBPP());
	m_ViewImage->Load(sFilename);

	m_EdgeWidth = image.GetWidth()/7;
	m_EdgeHeight= image.GetHeight()/7;

	for(int j=0; j<MeshSizeY; j++)
	{
		for(int i=0; i<MeshSizeX; i++)
		{
			m_NewMesh[i][j] = m_OldMesh[i][j] = CPoint(i* m_EdgeWidth, j*m_EdgeHeight);
		}
	}

	Invalidate();
}

int CImageProcessingDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	for(int i=0; i<MeshSizeX; i++)
	{
		for(int j=0; j<MeshSizeY; j++)
		{
			m_NewMesh[j][i] = m_OldMesh[j][i] = CPoint(i*100,1*500);
		}
	}
	m_ScrImage = new CImage();
	m_ViewImage = new CImage();
	m_isMouseMove = false;

#ifdef my_matrix
	m_mxWarpFactors = matrix_new( 3, 3 ); 
#else
	m_mxWarpFactors.SetSize( 3, 3 ); 
#endif
	return 0;
}

void CImageProcessingDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	//  ܰ ޽ ǵ帮 ʴ´.
	for(int j=1; j<MeshSizeY-1; j++)
	{
		for(int i=1; i<MeshSizeX-1; i++)
		{
			if((point.x >= m_OldMesh[i][j].x-5 && point.x <= m_OldMesh[i][j].x + 5) &&
				(point.y >= m_OldMesh[i][j].y-5 && point.y <= m_OldMesh[i][j].y + 5))
			{
				m_NewMesh[i][j] = point;
				m_SelPoint = CPoint(i,j);
				m_isMouseMove = true;
				break;
			}
		}
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CImageProcessingDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	if(m_isMouseMove)
	{
		m_isMouseMove = false;

		// ̹ κκ  
		/*
		if ( !m_ScrImage->IsNull() )
		{
			CalcPreMatrix();
			ImageWarping();
		}
		*/
		point.x -= 5;
		point.y -= 5;
		m_OldMesh[m_SelPoint.x][m_SelPoint.y] = point;
//		m_ViewImage->Destroy();
//		m_ViewImage->Create(m_ScrImage->GetWidth(), m_ScrImage->GetHeight(), m_ScrImage->GetBPP());
		//	ImageDivideDraw(m_SelPoint.x,m_SelPoint.y);
		//	ImageDivideDraw(m_SelPoint.x, m_SelPoint.y);
	
		this->Invalidate();
		//	OnBnClickedMeshset();
	}

	CDialog::OnLButtonUp(nFlags, point);
}

void CImageProcessingDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	// ޽ ϶ ۾ó
	if(m_isMouseMove)
	{
		point.x -= 5;
		point.y -= 5;

		m_NewMesh[m_SelPoint.x][m_SelPoint.y] = point;
	
		this->Invalidate();
	}	
	CDialog::OnMouseMove(nFlags, point);
}

//=========================================================================//
//  4 ̷ 簢  Լ...
//=========================================================================//

//  ̷ Ŀ,  x,y ׷  Ʒ ˷ִ Լ
float CImageProcessingDlg::LineAnInequality(CPoint LinePos1, CPoint LinePos2, int x, int y, float &tilt)
{
	if((LinePos2.x - LinePos1.x) == 0)
	{	// и 0̸..  , x = a    ȴ.
		tilt = 0;
		if(LinePos2.x == x)
			return true;
		else
			return false;
	}
	else if((LinePos2.y - LinePos1.y) == 0)	
	{	// ڰ 0̸..  , y = a   ó
		tilt = 0;
		if(LinePos2.y >= y)
			return true;
		else
			return false;
	}
	//  Ѵ.
	tilt = (float)(LinePos2.y - LinePos1.y) /  (float)(LinePos2.x - LinePos1.x)  ;

	//   ؼ..
	//   ϴ Լ  ߴ , 򿡼  ߻.. orz
	// Ƿ ׳ . ڹٷ ȯ  غ ..

	//  ũ⸦ ؼ
	float tmp = abs(tilt);
	
	bool flag;
	// Ⱑ 1̸ y  
	if(tmp <= 1)
	{
		if((int)y >= (int)((tilt  *  (float)(x - LinePos1.x) + LinePos1.y)))
			flag = true;
		else
			flag = false;
	}
	// Ⱑ 1̸̻ x      .
	if(tmp > 1)
	{
		if((int)x <= (int)((y-LinePos1.y)/tilt + LinePos1.x))
			flag = true;
		else
			flag = false;
	}
	
	return flag;
}

//   ֿ 4 ̷ 簢 ȿ ִ°?
//  Ʈ ȭ  , , , Ͽ  ´.
//  ..   y ۱ .. ̰  ؾ Ѵ.
//  ̴µ ؼ α׷ ϸ ȵ.
bool CImageProcessingDlg::IsRectIn(CPoint TopLeft, CPoint TopRight, CPoint DonwLeft, CPoint DownRight, int x, int y)
{

	//  ε ؼ  簢 ü ˰
	// ̺κ ؾ .. orz
	bool flag = false;	//  ÷
	float tilt;			//  ġ

	//   ε . ٽ ⸦ ´.
	flag = LineAnInequality(TopLeft, TopRight, x, y, tilt);
	if(tilt == 0)// || tilt > 1.5)
		flag = !flag;
	
	if(flag)
	{
		flag = !LineAnInequality(TopLeft, DonwLeft, x, y, tilt);
	//	if(tilt >= 0)
	//		flag = !flag;
		
		if(flag)
		{
			flag = LineAnInequality(DonwLeft,DownRight, x, y, tilt);
			if(tilt != 0)// || tilt >= 1.0f)
				flag = !flag;
			
			if(flag)
			{
				if(LineAnInequality(DownRight,TopRight, x, y, tilt))
				{
					//  4 ε ȿ ; true ޴´ Ѥ...
					// ̰    ٲµ..  ؾ ϳ _..
					flag = true;
				}
				else
					flag = false;
			}
		}
	
	}
	return flag;
}

void CImageProcessingDlg::DrawWarpingRect(int drawX, int drawY)
{
	int dw = 0, dh = 0;
	int NewRectAreaX=0, NewRectAreaY=0;

	CalcRectSize(drawX, drawY, dw, dh);
	CalcNewRectPosition(drawX, drawY, NewRectAreaX, NewRectAreaY);
	dw++;
	dh++;
	
	//  簢 ܴ´.
	CImage *RectImage;
	RectImage = new CImage();
	RectImage->Create(dw, dh, m_ScrImage->GetBPP());
	
	//  κ  ؼ ߿ ؼ ȵǴ ؾ .
	// ϴܿ ܾ ˰..
	CPoint pt[4];
	pt[0] = m_NewMesh[drawX][drawY]		 -		m_NewMesh[drawX][drawY];
	pt[3] = m_NewMesh[drawX+1][drawY]	 -		m_NewMesh[drawX][drawY];
	pt[1] = m_NewMesh[drawX][drawY+1]	 -		m_NewMesh[drawX][drawY];
	pt[2] = m_NewMesh[drawX+1][drawY+1]	 -		m_NewMesh[drawX][drawY];
	//   ʹ ð ݴ ư Ѵ.
	CRgn rgn;
	rgn.CreatePolygonRgn(pt, 4, ALTERNATE);
	int dx=0, dy=0;
	for(int y = NewRectAreaY; y < NewRectAreaY + dh; y++, dy++)
	{
		dx=0;
		for(int x=NewRectAreaX; x < NewRectAreaX + dw; x++, dx++)
		{
			// Ͱ  ̾ ̳?
			if(rgn.PtInRegion(dx,dy))
				RectImage->SetPixel(dx, dy, m_ScrImage->GetPixel(x, y));
			else
				RectImage->SetPixel(dx, dy, RGB(0,0xff,0));
		}
	}
	//  ޽  ٸŶ .
/*	if(m_OldMesh[drawX][drawY] == m_NewMesh[drawX][drawY] &&
		m_OldMesh[drawX+1][drawY] == m_NewMesh[drawX+1][drawY] &&
		m_OldMesh[drawX][drawY+1] == m_NewMesh[drawX][drawY+1] &&
		m_OldMesh[drawX+1][drawY+1] == m_NewMesh[drawX+1][drawY+1])
	{

	}
	else
*/	{
		// ̹ Ѵ.. ̰ apply ư  ;;
		// ⸸ ٽ Ϻ ϸ ̰ Ŭ. orz
		ImageWarping(drawX, drawY, RectImage);
	}

	// ٽ δ.
	dy=0;
	for(int y = NewRectAreaY; y < NewRectAreaY + dh; y++, dy++)
	{
		dx=0;
		for(int x=NewRectAreaX; x < NewRectAreaX + dw; x++, dx++)
		{
			COLORREF temp = RectImage->GetPixel(dx,dy);
			if(temp != COLORREF(RGB(0,0xff,0)))
				m_ViewImage->SetPixel(x,y, temp);
		}
	}

	delete RectImage;

}

//=========================================================================//
// ̹ ε ʿ Լ
//=========================================================================//

// Ž Ǽ  簢  ũ ϱ
// ڰ StartPosition  ޾ƿ.   » δ 簢  .
void CImageProcessingDlg::CalcRectSize(int ImageX, int ImageY, int &Width, int &Height)
{
	/* 簢 
	  |    a.-------.b    ----------------> x
	  |     |       |
	  |    c.-------.d
	 y|   
      v

	  ̴ a,c  b,d ū  
	  ̴ a,b  c,d ū  
	*/
	
	int temp1, temp2;
	
	//  ϱ
	if(m_NewMesh[ImageX][ImageY].x < m_NewMesh[ImageX][ImageY+1].x)	// a c a  
		temp1 = m_NewMesh[ImageX][ImageY].x;						// <- a x
	else	
		temp1 = m_NewMesh[ImageX][ImageY+1].x;						// <- c x
	if(m_NewMesh[ImageX+1][ImageY].x < m_NewMesh[ImageX+1][ImageY+1].x)	// b d b  
		temp2 = m_NewMesh[ImageX+1][ImageY+1].x;					// <- d x
	else
		temp2 = m_NewMesh[ImageX+1][ImageY].x;						// <- b x

	Width = (temp2 - temp1);

	//  ϱ
	if(m_NewMesh[ImageX][ImageY].y < m_NewMesh[ImageX+1][ImageY].y)	// a b a  
		temp1 = m_NewMesh[ImageX][ImageY].y;						// <- a y
	else
		temp1 = m_NewMesh[ImageX+1][ImageY].y;						// <- b y
	if(m_NewMesh[ImageX][ImageY+1].y < m_NewMesh[ImageX+1][ImageY+1].y)	// c d c  
		temp2 = m_NewMesh[ImageX+1][ImageY+1].y;					// <- d y
	else
		temp2 = m_NewMesh[ImageX][ImageY+1].y;						// <- c y

	Height = (temp2 - temp1);

}

//  Ǵ 簢   Ѵ.
void CImageProcessingDlg::CalcNewRectPosition(int ImageX, int ImageY, int &NewRectX, int &NewRectY)
{
	if(m_NewMesh[ImageX][ImageY].x < m_NewMesh[ImageX][ImageY+1].x)
		NewRectX = m_NewMesh[ImageX][ImageY].x;
	else
		NewRectX = m_NewMesh[ImageX][ImageY+1].x;

	if(m_NewMesh[ImageX][ImageY].y < m_NewMesh[ImageX+1][ImageY].y)
		NewRectY = m_NewMesh[ImageX][ImageY].y;
	else
		NewRectY = m_NewMesh[ImageX+1][ImageY].y;

}
//   ׸ ˹ ġ Ѿ° üũ
bool CImageProcessingDlg::BoundCheck(int x, int y, int new_ImageX, int new_ImageY)	
{
	if(x >= 0 && x < new_ImageX && y>=0 && y < new_ImageY)
		return true;

	return false;
}

// ο ϴ Ʈ Ѵ.
// ʿ  ʿ 簢 ġ ǥ, ̵ 簢 ġ ǥ  8 ʿϴ.
void CImageProcessingDlg::CalcPreMatrix(int RectPosX, int RectPosY)
{
	
#ifdef my_matrix
	matrix* a;				// left matrix
	matrix* b;				// right matrix
	matrix* c;				//  matrix
	matrix* a_inv;			// a Լ

	matrix_free(m_mxWarpFactors);
	m_mxWarpFactors = matrix_new(3,3);

	// In perspective mode, the warping functions are:
	//  ذ ؼ http://rosagigantea.tistory.com/171  Ұ
	//   Ʈ  Ʈ ũ 8x8   Ѱ.
	// ũ ҽ ణ  ٲ.. orz
	a = matrix_new( 8, 8 ); 
	b = matrix_new( 8, 1 );
	
	a->var[0][0] = m_OldMesh[RectPosX][RectPosY].x;
	a->var[0][1] = m_OldMesh[RectPosX][RectPosY].y;
	a->var[0][2] = 1.0;
	a->var[0][6] = -1 * m_OldMesh[RectPosX][RectPosY].x * m_OldMesh[RectPosX][RectPosY].x;
	a->var[0][7] = -1 * m_OldMesh[RectPosX][RectPosY].x * m_OldMesh[RectPosX][RectPosY].y;

	a->var[2][0] = m_OldMesh[RectPosX][RectPosY+1].x;
	a->var[2][1] = m_OldMesh[RectPosX][RectPosY+1].y;
	a->var[2][2] = 1.0;
	a->var[2][6] = -1 * m_OldMesh[RectPosX][RectPosY+1].x * m_OldMesh[RectPosX][RectPosY+1].x;
	a->var[2][7] = -1 * m_OldMesh[RectPosX][RectPosY+1].x * m_OldMesh[RectPosX][RectPosY+1].y;

	a->var[4][0] = m_OldMesh[RectPosX+1][RectPosY].x;
	a->var[4][1] = m_OldMesh[RectPosX+1][RectPosY].y;
	a->var[4][2] = 1.0;
	a->var[4][6] = -1 * m_OldMesh[RectPosX+1][RectPosY].x * m_OldMesh[RectPosX+1][RectPosY].x;
	a->var[4][7] = -1 * m_OldMesh[RectPosX+1][RectPosY].x * m_OldMesh[RectPosX+1][RectPosY].y;

	a->var[6][0] = m_OldMesh[RectPosX+1][RectPosY+1].x;
	a->var[6][1] = m_OldMesh[RectPosX+1][RectPosY+1].y;
	a->var[6][2] = 1.0;
	a->var[6][6] = -1 * m_OldMesh[RectPosX+1][RectPosY+1].x * m_OldMesh[RectPosX+1][RectPosY+1].x;
	a->var[6][7] = -1 * m_OldMesh[RectPosX+1][RectPosY+1].x * m_OldMesh[RectPosX+1][RectPosY+1].y;

	a->var[1][3] = m_OldMesh[RectPosX][RectPosY].x;
	a->var[1][4] = m_OldMesh[RectPosX][RectPosY].y;
	a->var[1][5] = 1.0;
	a->var[1][6] = -1 * m_OldMesh[RectPosX][RectPosY].x * m_OldMesh[RectPosX][RectPosY].y;
	a->var[1][7] = -1 * m_OldMesh[RectPosX][RectPosY].y * m_OldMesh[RectPosX][RectPosY].y;

	a->var[3][3] = m_OldMesh[RectPosX][RectPosY+1].x;
	a->var[3][4] = m_OldMesh[RectPosX][RectPosY+1].y;
	a->var[3][5] = 1.0;
	a->var[3][6] = -1 * m_OldMesh[RectPosX][RectPosY+1].x * m_OldMesh[RectPosX][RectPosY+1].y;
	a->var[3][7] = -1 * m_OldMesh[RectPosX][RectPosY+1].y * m_OldMesh[RectPosX][RectPosY+1].y;

	a->var[5][3] = m_OldMesh[RectPosX+1][RectPosY].x;
	a->var[5][4] = m_OldMesh[RectPosX+1][RectPosY].y;
	a->var[5][5] = 1.0;
	a->var[5][6] = -1 * m_OldMesh[RectPosX+1][RectPosY].x * m_OldMesh[RectPosX+1][RectPosY].y;
	a->var[5][7] = -1 * m_OldMesh[RectPosX+1][RectPosY].y * m_OldMesh[RectPosX+1][RectPosY].y;

	a->var[7][3] = m_OldMesh[RectPosX+1][RectPosY+1].x;
	a->var[7][4] = m_OldMesh[RectPosX+1][RectPosY+1].y;
	a->var[7][5] = 1.0;
	a->var[7][6] = -1 * m_OldMesh[RectPosX+1][RectPosY+1].x * m_OldMesh[RectPosX+1][RectPosY+1].y;
	a->var[7][7] = -1 * m_OldMesh[RectPosX+1][RectPosY+1].y * m_OldMesh[RectPosX+1][RectPosY+1].y;

	b->var[0][0] = m_OldMesh[RectPosX][RectPosY].x;
	b->var[2][0] = m_OldMesh[RectPosX][RectPosY+1].x;
	b->var[4][0] = m_OldMesh[RectPosX+1][RectPosY].x;
	b->var[6][0] = m_OldMesh[RectPosX+1][RectPosY+1].x;
	b->var[1][0] = m_OldMesh[RectPosX][RectPosY].y;
	b->var[3][0] = m_OldMesh[RectPosX][RectPosY+1].y;
	b->var[5][0] = m_OldMesh[RectPosX+1][RectPosY].y;
	b->var[7][0] = m_OldMesh[RectPosX+1][RectPosY+1].y;

	a_inv = matrix_inv(a); 
	c = matrix_multiple( a_inv, b ); 

	m_mxWarpFactors->var[0][0] = c->var[0][0]; 
	m_mxWarpFactors->var[0][1] = c->var[1][0]; 
	m_mxWarpFactors->var[0][2] = c->var[2][0]; 

	m_mxWarpFactors->var[1][0] = c->var[3][0]; 
	m_mxWarpFactors->var[1][1] = c->var[4][0]; 
	m_mxWarpFactors->var[1][2] = c->var[5][0]; 

	m_mxWarpFactors->var[2][0] = c->var[6][0]; 
	m_mxWarpFactors->var[2][1] = c->var[7][0]; 
	m_mxWarpFactors->var[2][2] = 1.0; 

	matrix_free(a); 
	matrix_free(b); 
	matrix_free(c); 
	matrix_free(a_inv); 

#else
	// In perspective mode, the warping functions are:
	//	x' = (a0 + a1 x + a2 y) / (c0 x + c1 y + 1)
	//	y' = (b0 + b1 x + b2 y) / (c0 x + c1 y + 1)
	//
	// The following calculates the factors a#, b# and c#.
	// We do this by creating a set of eight equations with a#, b# and c# as unknowns.
	// The equations are derived by:
	// 1. substituting the srcPoints for (x, y);
	// 2. substituting the corresponding destPoints for (x', y');
	// 3. solving the resulting set of equations, with the factors as unknowns.
	//
	// The equations are like these:
	//	a0	x a1	y a2	0		0		0		-xx'c0	-yx'c1	= x'
	//	0	0		0		b0		x b1	y b2	-xy'c0	-yy'c1  = y'
	// The known factors of left hand side ar put in the 8x8 matrix mxLeft for
	// all four point pairs, and the right hand side in the one column matrix mxRight.
	// After solving, m_mxWarpFactors contains a0, a1, a2, b0, b1, b2, c0, c1.

	math::matrix<REAL> mxLeft(8, 8);
	mxLeft.Null();
	math::matrix<REAL> mxRight(8, 1);

	CPoint srcPoints[4], destPoints[4];

	for(int i=0; i<2; i++)
	{
		for(int j=0; j<2; j++)
		{
			srcPoints[i*2+j] = m_OldMesh[i][j];
			destPoints[i*2+j] = m_NewMesh[i][j];
		}
	}

	size_t row = 0;
	for (int i = 0; i < 4; i++)
	{
		mxLeft(row, 0) = 1.0f;
		mxLeft(row, 1) = srcPoints[i].x;
		mxLeft(row, 2) = srcPoints[i].y;

		mxLeft(row, 6) = - srcPoints[i].x * destPoints[i].x;
		mxLeft(row, 7) = - srcPoints[i].y * destPoints[i].x;

		mxRight(row, 0) = destPoints[i].x;

		row++;

		mxLeft(row, 3) = 1.0f;
		mxLeft(row, 4) = srcPoints[i].x;
		mxLeft(row, 5) = srcPoints[i].y;

		mxLeft(row, 6) = - srcPoints[i].x * destPoints[i].y;
		mxLeft(row, 7) = - srcPoints[i].y * destPoints[i].y;

		mxRight(row, 0) = destPoints[i].y;

		row++;
	}
	math::matrix<REAL> mxtemp;
	mxtemp = mxLeft.Solve(mxRight);

	m_mxWarpFactors(0,0) = mxtemp(1,0);			// a
	m_mxWarpFactors(0,1) = mxtemp(2,0);			// b
	m_mxWarpFactors(0,2) = mxtemp(0,0);			// c
	m_mxWarpFactors(1,0) = mxtemp(4,0);			// d
	m_mxWarpFactors(1,1) = mxtemp(5,0);			// e
	m_mxWarpFactors(1,2) = mxtemp(3,0);			// f
	m_mxWarpFactors(2,0) = mxtemp(6,0);			// g
	m_mxWarpFactors(2,1) = mxtemp(7,0);			// h
	m_mxWarpFactors(2,2) = 1.0;					// 1
	/*
	// In bilinear mode, the warping functions are:
	//	x' = a0 + a1 x y + a2 x + a3 y
	//	y' = b0 + b1 x y + b2 x + b3 y
	//
	// Here, we have two sets of four equations. In the first set, the a# factors
	// are the unknowns, in the second set the b# factors.
	// The equations are of the form:
	//	a0		+ xy a1		+ x a2		+ y a3	= x'
	// The left hand side is identical for both sets. The right hand side differs.
	// Therefore, we can solve them in one operation.
	// The left hand side factors are put in the 4x4 matrix mxLeft, the right side
	// factors are put in the 4x2 matrix mxRight.
	// After solving, the first column of m_mxWarpFactors contains a0, a1, a2, a3; the
	// second columne contains b0, b1, b2, b3.
	math::matrix<REAL> mxLeft(4, 4);
	math::matrix<REAL> mxRight(4, 2);

	for (size_t row = 0; row < 4; row++)
	{
	mxLeft(row, 0) = 1.0f;
	mxLeft(row, 1) = srcPoints[row].X * srcPoints[row].Y;
	mxLeft(row, 2) = srcPoints[row].X;
	mxLeft(row, 3) = srcPoints[row].Y;

	mxRight(row, 0) = destPoints[row].X;
	mxRight(row, 1) = destPoints[row].Y;
	}

	m_mxWarpFactors = mxLeft.Solve(mxRight);
	*/
	// In perspective mode, the warping functions are:
	//  ذ ؼ http://rosagigantea.tistory.com/171  Ұ

#endif
}

//    ǽѴ.
// ⿡   backward mapping ̴.
// ڷ http://rosagigantea.tistory.com/171  Ʈ س.
void CImageProcessingDlg::ImageWarping(int startX, int startY, CImage *Image)
{
	CImage *BufferImage;
	BufferImage = new CImage();

	int new_ImageX = 0;
	int new_ImageY = 0;
	CalcRectSize(startX, startY, new_ImageX, new_ImageY);		
	new_ImageX++;
	new_ImageY++;

	BufferImage->Create(new_ImageX, new_ImageY, Image->GetBPP());

	CalcPreMatrix(startX, startY);

#ifdef my_matrix
	//  ϱ
	matrix *mxTemp;
	mxTemp = matrix_inv(m_mxWarpFactors);

	// ϴ ⺻ backward mapping   intel ¼   غ.
	//   , ϴ װ ȼ 迭 Ǯ Ѵ; orz
	for(int y=0; y < new_ImageY; y++)
	{
		for(int x=0; x < new_ImageX; x++)
		{
			double num = mxTemp->var[2][0] * x + mxTemp->var[2][1] * y + 1.0f;
			if (fabs(num) < epsilon) return ;

			int pos_x = (int)((mxTemp->var[0][0] * x + mxTemp->var[0][1] * y + mxTemp->var[0][2] ) / num);
			int pos_y = (int)((mxTemp->var[1][0] * x + mxTemp->var[1][1] * y + mxTemp->var[1][2] ) / num);

			if(BoundCheck(pos_x, pos_y, Image->GetWidth(), Image->GetHeight()))
			{
				//   ǽ.
				BufferImage->SetPixel(x, y, Image->GetPixel(pos_x, pos_y));
			}
			else
			{
				BufferImage->SetPixel(x, y, COLORREF(RGB(0,0xff,0)));
			}
		}
	}
	for(int y=0; y < new_ImageY; y++)
	{
		for(int x=0; x < new_ImageX; x++)
		{
			Image->SetPixel(x,y,BufferImage->GetPixel(x,y));
		}
	}
//	delete Image;
//	Image = BufferImage;	// ٲġ _.. ϰ .   ༮.. orz  ʹ ģ
	delete BufferImage;
	matrix_free(mxTemp);
#else

	//  ϱ
	math::matrix<REAL> mxTemp = m_mxWarpFactors.Inv();
	// ϴ ⺻ backward mapping   intel ¼   غ.
	//   , ϴ װ ȼ 迭 Ǯ Ѵ; orz
	for(int y=0; y < new_ImageY; y++)
	{
		for(int x=0; x < new_ImageX; x++)
		{
			double num = mxTemp(2,0) * x + mxTemp(2,1) * y + 1.0f;
			if (fabs(num) < epsilon) return ;

			int pos_x = (int)((mxTemp(0,0) * x + mxTemp(0,1) * y + mxTemp(0,2) ) / num);
			int pos_y = (int)((mxTemp(1,0) * x + mxTemp(1,1) * y + mxTemp(1,2) ) / num);

			if(BoundCheck(pos_x, pos_y, Image->GetWidth(), Image->GetHeight()))
			{
				//   ǽ.
				BufferImage->SetPixel(x, y, Image->GetPixel(pos_x, pos_y));
			}
			else
			{
				BufferImage->SetPixel(x, y, COLORREF(RGB(0,0xff,0)));
			}
		}
	}
	for(int y=0; y < new_ImageY; y++)
	{
		for(int x=0; x < new_ImageX; x++)
		{
			Image->SetPixel(x,y,BufferImage->GetPixel(x,y));
		}
	}
	//	Image = BufferImage;	// ٲġ _.. ϰ .   ༮.. orz  ʹ ģ
	delete BufferImage;
#endif
}

void CImageProcessingDlg::OnBnClickedMeshformat()
{
	// TODO: Add your control notification handler code here
	for(int j=0; j<MeshSizeY; j++)
	{
		for(int i=0; i<MeshSizeX; i++)
		{
			m_NewMesh[i][j] = m_OldMesh[i][j] = CPoint(i* m_EdgeWidth, j*m_EdgeHeight);
		}
	}

	Invalidate();
}

// ó ޽ Ѵ.
void CImageProcessingDlg::OnBnClickedMeshset()
{
	// TODO: Add your control notification handler code here
	for(int j=0; j<MeshSizeY; j++)
	{
		for(int i=0; i<MeshSizeX; i++)
		{
			m_OldMesh[i][j] = m_NewMesh[i][j];
		}
	}
	m_SelPoint = CPoint(0,0);
}

//   ŸƮ
void CImageProcessingDlg::OnBnClickedApply()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
}

void CImageProcessingDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	//int x = point.x / m_EdgeWidth;
	//int y = point.y / m_EdgeHeight;
	
//	DrawWarpingRect(x,y);

	for(int x=0; x< 7 ; x++)
	{
		for(int y=0; y< 7; y++)
		{
			DrawWarpingRect(x,y);
		}
	}
	this->Invalidate();
	CDialog::OnRButtonDown(nFlags, point);
}

