// ImageProcessingDlg.h : header file
//
#include "matrix.h"
#pragma once

// ӵ üũϱ + - * / Ǵ° ī͸   


const REAL epsilon = 1.0e-18f;
// REAL range: 1.175494351e?8 ... 3.402823466e+38

const int MeshSizeX = 8;
const int MeshSizeY = 8;

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

// CImageProcessingDlg dialog
class CImageProcessingDlg : public CDialog
{
// Construction
public:
	CImageProcessingDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_IMAGEPROCESSING_DIALOG };

private:
	//  ׸   Ѵ üũϴ Լ
	bool BoundCheck(int x, int y, int new_ImageX, int new_ImageY);

	//------------------------  Լ ------------------------//
	//  Ʈ , 
	// ڰ StartPosition  ޾Ƽ. » δ 簢  .
	//  Ǵ 簢  ϴ Լ.
	void CalcPreMatrix(int RectPosX, int RectPosY);			
	void CalcRectSize(int ImageX, int ImageY, int &Width, int &Height);
	void CalcNewRectPosition(int ImageX, int ImageY, int &NewRectX, int &NewRectY);

	//  ο ؼ ϴ κ
	void ImageWarping(int startX, int startY, CImage *scrImage);	
	//void bwarping_i( u32* dst, u32* src, matrix* p, int new_ImageX, int new_ImageY );
	
	//------- ̹ ޽  ڸµ ʿ Լ ---------//
	// (drawX,drawY)ǥ ׸ ׸ Ѵ.
	void DrawWarpingRect(int drawX, int drawY);
	//  ̷ εĿ,  x,y ׷  Ʒ ˷ִ Լ
	float LineAnInequality(CPoint LinePos1, CPoint LinePos2, int x, int y, float &tilt);
	// 4  ȿ (x,y)  Ȯϴ Լ
	bool IsRectIn(CPoint TopLeft, CPoint TopRight, CPoint DonwLeft, CPoint DownRight, int x, int y);

private:
	CString sFilename;							// ̹  ̸
	CImage *m_ScrImage;							//  ̹
    CImage *m_ViewImage;						//  ̹ 

	CPoint m_OldMesh[MeshSizeX][MeshSizeY];		// ޽ ġ
	CPoint m_NewMesh[MeshSizeX][MeshSizeY];		// ޽ ġ
	CPoint m_SelPoint;
	
	bool m_isMouseMove;							// 콺 ̰ ִ°?
	int m_EdgeWidth;							//  α
	int m_EdgeHeight;							//  α

#ifdef my_matrix
	matrix *m_mxWarpFactors;					//  
#else
	math::matrix<REAL> m_mxWarpFactors;			//  
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedImageload();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnBnClickedMeshformat();
	afx_msg void OnBnClickedMeshset();
	afx_msg void OnBnClickedApply();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
};
